<?php

class tx_tcdirectmail_mailer {
    /* Vars that might need to be overridden */
    var $senderName = "Test";
    var $senderEmail = "test@test.net";
    var $replytoName;
    var $replytoEmail;
    var $domain;
    
    function tx_tcdirectmail_mailer () {
	$this->hostname = trim(`hostname -f`);
	$this->realPath = PATH_site;
    }
    
    function getMimeType($filename) {
	/* Just give the result of UNIX "file"-command. This makes it absolutely incompatible with windoze. 
	   If you know how to get the mime in at cheap way on win32, feel free to make a patch 	*/
	print ("Get Mime: $filename\n\n");
	return preg_replace ('/;.*$/', '', trim(`file -bi $filename`));
    }
    
    function addAttachment($filename) {
	if (trim($filename) != '') {
	    $path = explode ('/', $filename);
	    $basename = array_pop ($path);
    
	    print ("Attaching $filename\n");
    
	    $this->files[$basename] = base64_encode(file_get_contents($filename));
	    $this->mimes[$basename] = $this->getMimeType($filename);
	}
    }
    
    function setPlain ($src) {
	/* Remove html-comments */
	$src = preg_replace('/<!--.*-->/U', '', $src);
    
	$this->plain_tpl = $src;
	$this->plain = $src;
    }
    
    function setHtml ($src) {
	/* Remove html-comments */
	$src = preg_replace('/<!--.*-->/U', '', $src);
    
	/* Find title */
	preg_match('|<title>(.*)</title>|Ui', $src, $title);
	$this->title = $title[1];
    
	/* Find images and the like,  substitute paths, and encode for attachment */
	preg_match_all('/ src="([^"]+)"/', $src, $urls);
	foreach ($urls[1] as $url) {
	    $get_url = str_replace("http://$this->domain/", '', $url);
	    $name = explode ('.', $get_url);
	    $ext = array_pop ($name);
	    $substname = substr(md5($url), 0, 10).'.'.$ext.'@'.$this->hostname;
	    $this->inlinefiles[$substname] = base64_encode(file_get_contents("$this->realPath/$get_url"));
	    $this->inlinemimes[$substname] = $this->getMimeType("$this->realPath/$get_url");
	    $src = str_replace ($url, "cid:$substname", $src);
	}
	
	/* Find css, substitute, attach */
	preg_match_all('|<link rel="stylesheet" type="text/css" href="(.*)"|Ui', $src, $urls);
	foreach ($urls[1] as $url) {
	    $get_url = str_replace("http://$this->domain/", '', $url);
	    $name = explode ('.', $get_url);
	    $ext = array_pop ($name);
	    $substname = substr(md5($url), 0, 10).'.'.$ext.'@'.$this->hostname;
	    $this->inlinefiles[$substname] = base64_encode(file_get_contents("$this->realPath/$get_url"));
	    $this->inlinemimes[$substname] = $this->getMimeType("$this->realPath/$get_url");
	    $src = str_replace ($url, "cid:$substname", $src);	    
	}
	
	/* Fix relative links */
	preg_match_all ('|<a [^>]*href="(.*)"|Ui', $src, $urls);
	foreach ($urls[1] as $i => $url) {
		/* If this is already a absolute link, dont replace it */
		if (!preg_match('|^http://|', $url)) {
		    $replace_url = str_replace($url, "http://$this->domain/$url", $urls[0][$i]);
		    print ("Replacing: ".$urls[0][$i]." -> $replace_url\n");
		    $src = str_replace ($urls[0][$i], $replace_url, $src);
		}
	}
    
	$this->html_tpl = $src;
	$this->html = $src;
    }
    
    function insertSpy($id) {
	$this->html = str_replace (
	                '</body>', 
			'<div><img src="http://'.$this->domain.'/typo3conf/ext/tcdirectmail/beenthere.php?uid='.$id.'" width="0" height="0" /></div></body>', 
			$this->html);
    }
    
    function resetMarkers() {
	$this->html  = $this->html_tpl;
	$this->plain = $this->plain_tpl;
    }
    
    function substituteMarker($name, $value) {
	$this->html  = str_replace("###$name###", $value, $this->html);
	$this->plain = str_replace("###$name###", $value, $this->plain);
    }
    
    function send($receiverRecord) {
	$messageId = md5(microtime().$receiverRecord['email']).'@'.$this->hostname;
	$boundary  = "WE_COME_IN_PEACE__".substr($messageId, 0,10);
	$body      = array();
	$headers   = array();
    
	$headers[] = "From: $this->senderName <$this->senderEmail>";
	$headers[] = "MIME-Version: 1.0";
	$headers[] = "Message-ID: <$messageId>";
	$headers[] = "X-Mailer: TYPO3 CMS <typo3.com> / tcdirectmail extension <www.typoconsult.dk>";
	
	$body[] = "This is a multi-part message in MIME format.";
	$body[] = '';
	
	/* Substitute the markers */
	foreach ($receiverRecord as $mark => $value) {
	    $this->substituteMarker($mark, $value);
	}
	
	
	/* Plain text? */
	if ($receiverRecord['plain_only'] == 1) {
	    $headers[] = "Content-Type: multipart/mixed; boundary=\"$boundary\"";
	    
    	    $body[] = "--$boundary";
	    $body[] = "Content-Type: text/plain; charset=iso-8859-1";
	    $body[] = "Content-Transfer-Encoding: base64";
	    $body[] = '';
	    $body[] = chunk_split(base64_encode($this->plain));
	    $body[] = '';
	        
	/* or mixed */
	} else {
	    $headers[] = "Content-type: multipart/related; boundary=\"$boundary\"";	
	    
	    /* Envelope for the text and html versions */
	    $body[] = "--$boundary";
	    $body[] = "Content-Type: multipart/alternative; boundary=\"$boundary,_$boundary\"";	
	    $body[] = '';
	    
	    /* For the alternativ html and text versions */
    	    $body[] = "--$boundary,_$boundary";
	    $body[] = "Content-Type: text/plain; charset=iso-8859-1";
	    $body[] = "Content-Transfer-Encoding: base64";
	    $body[] = '';
	    $body[] = chunk_split(base64_encode($this->plain));
	    $body[] = "--$boundary,_$boundary";
	    $body[] = "Content-Type: text/html";
	    $body[] = "Content-Disposition: inline";
	    $body[] = "Content-Transfer-Encoding: base64";
	    $body[] = '';
	    $body[] = chunk_split(base64_encode($this->html));
	    $body[] = "--$boundary,_$boundary--";
	    $body[] = '';
	    /* End of subboundary */
		    
	    /* Get the inline files for use with pictures, stylesheets etc. */
	    foreach ($this->inlinefiles as $filename => $content) {
		$body[] = "--$boundary";
		$body[] = "Content-Type: ".$this->inlinemimes[$filename];
		$body[] = "Content-ID: $filename";
		$body[] = "Content-Disposition: inline";
		$body[] = "Content-Transfer-Encoding: base64";
		$body[] = '';
		$body[] = chunk_split($content);
		$body[] = '';
	    }
	}
	
	/* Attach the files */
	foreach ($this->files as $filename => $content) {
	    $body[] = "--$boundary\nContent-Type: ".$this->mimes[$filename];
	    $body[] = " name=\"$filename\"";
	    $body[] = "Content-Disposition: attachment; filename=\"$filename\"";
	    $body[] = "Content-Transfer-Encoding: base64";
	    $body[] = '';
	    $body[] = chunk_split($content);
	    $body[] = '';
	}
	
	$body[] = "--$boundary--";	
	
	/* Mail it */
	mail ($receiverRecord['email'], $this->title, implode("\n", $body), implode("\n", $headers));
	$this->resetMarkers();
    }
}
?>