<?php

class tx_tcdirectmail_query {
    function handleWhereClause ($wheres) {
	$arr = array("1 = 1 \n");
	foreach ($wheres as $where) {
	    switch ($where['type']) {
    		case '=' 		: $arr[] = " $where[field] = '$where[value]' \n"; break;
    		case '<>' 		: $arr[] = " $where[field] <> '$where[value]' \n"; break;
    		case 'in' 		: $arr[] = " $where[field] in ($where[value]) \n"; break;
    		case 'like' 	: $arr[] = " $where[field] LIKE '%$where[value]%' \n"; break;
    		case 'contains'	: $arr[] = " FIND IN SET($where[value], $where[field]) \n"; break;
	    }
	}

	return " WHERE ".implode(' AND ', array_filter($arr));
    }

    function whichTCAtables ($sql) {
	preg_match_all ('/###tca_(.*)###/', $sql, $matches);
    
	$tables = array();
	foreach ($matches[1] as $i => $match) {
	    $tables[] = $matches[1][$i];
	}
    
	return $tables;
    }

    function getSubstRealSQL ($uid) {
	global $TYPO3_DB;

	$sql = tx_tcdirectmail_query::getSQL($uid);
	$tables = tx_tcdirectmail_query::whichTCAtables($sql);
    
	$rs = $TYPO3_DB->exec_SELECTquery('config', 'tx_tcdirectmail_targets', "uid = $uid");
	list ($config) = $TYPO3_DB->sql_fetch_row($rs);   
	$rows = explode ("\n", $config);
	$rows = array_map('trim', $rows);
    
	$rownum = 0;
    
	if (is_array($tables)) {
	    foreach ($tables as $table) {
		$select_uids = explode (',', trim($rows[$rownum], '* ,'));
		$select_uids[] = -1;
		$select_uids =  array_filter ($select_uids);
		$sql = str_replace ("###tca_$table###", '('.implode(',', $select_uids).')', $sql);
		$rownum++;
	    }
	}

	return $sql;
    }

    function getSQL($uid, $select_type = 'total') {
	global $TYPO3_DB;
    
	$rs = $TYPO3_DB->exec_SELECTquery('setup, config', 'tx_tcdirectmail_targets', "uid = $uid");
	list($setup, $config) = $TYPO3_DB->sql_fetch_row($rs);
	$setup_lines = explode ("\n", $setup);
	    
	$wheres = array();
	$known_wheres = array();
	    
	// Analyze the setup
	foreach ($setup_lines as $line) {
	    $line = trim($line);
		
	    if (preg_match('/^where:/', $line)) {
		list($field, $type, $value) = explode (';', str_replace('where:', '', $line));
	    
		if (preg_match('/\./', $field)) {
		    $wheres[] = array('type' => $type, 'value' => $value, 'field' => $field);
		} else {
		    $additionalWheres .= " AND $field.uid IN ###tca_$field### \n";
		    $tca_select[] = $field;
		}	    
	    }
		
	    if (preg_match('/^join:/', $line)) {
		list($table, $local, $foreign) = explode (';', str_replace('join:', '', $line));

		t3lib_div::loadTCA($table);
        	$enablefields = t3lib_befunc::BEenableFields($table);
		if (trim($enablefields) != 'AND') {
	    	    $enable_SQL .= $enablefields;
		}						    
		$joins .= " INNER JOIN $table ON $local = $foreign \n";
	    }
		
	    if (preg_match('/^source:/', $line)) {
		list ($source,$select_fields) = explode (';', str_replace('source:', '', $line));
		t3lib_div::loadTCA($source);
		if (trim($enablefields) != 'AND') {
	    	    $enable_SQL .= $enablefields;
		}
	    }
	}
	    
	// Compile the real sql
	if ($select_fields && $select_type == 'total') {
	    $sql .= "SELECT DISTINCT $select_fields FROM $source \n";
	} elseif ($select_type == 'total') {
	    $sql .= "SELECT DISTINCT $source.* FROM $source \n";
	} else {
	    $sql .= "SELECT DISTINCT $select_type.* FROM $source \n";
	}
	    
	$sql .= $joins;
	$sql .= tx_tcdirectmail_query::handleWhereClause($wheres);
	    
	if ($select_type == 'total') {
	    $sql .= $additionalWheres;
	}
    
	$sql .= $enable_SQL;
	    
	return $sql;
    }
}

?>