<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Daniel Schledermann (daniel@typoconsult.dk)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module 'Directmail' for the 'tcdirectmail' extension.
 *
 * @author	Daniel Schledermann <daniel@typoconsult.dk>
 */





	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);	
require ("conf.php");
require ($BACK_PATH."init.php");
require ($BACK_PATH."template.php");
require ('../class.tx_tcdirectmail_query.php');
$LANG->includeLLFile("EXT:tcdirectmail/mod1/locallang.php");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

class tx_tcdirectmail_module1 extends t3lib_SCbase {
	var $pageinfo;

	/**
	 * 
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		
		parent::init();

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
		$TYPO3_DB = $GLOBALS['TYPO3_DB'];
		
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 */
	function menuConfig()	{
		global $LANG;
		$this->MOD_MENU = Array (
			"function" => Array (
				"1" => $LANG->getLL("status"),
				"2" => $LANG->getLL("stats"),
				"3" => $LANG->getLL("examples"),
			)
		);
		parent::menuConfig();
	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		
		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{
	
				// Draw the header.
			$this->doc = t3lib_div::makeInstance("bigDoc");
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form='<form action="" method="POST">';

				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				</script>
			';

			$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
			$this->content.=$this->doc->divider(5);

			
			// Render content:
			$this->moduleContent();

			
			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
			}
		
			$this->content.=$this->doc->spacer(10);
		} else {
				// If no access or if ID == zero
		
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
		
			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	}

	/**
	 * Prints out the module HTML
	 */
	function printContent()	{

		$this->content.=$this->doc->endPage();
		echo $this->content;
	}
	
	/**
	 * Generates the module content
	 */
	function moduleContent()	{
		global $LANG;
		if (!$_REQUEST['id']) return;
		
		switch((string)$this->MOD_SETTINGS["function"])	{
			case 1:
				$content = $this->viewStatus();
				$this->content.=$this->doc->section($LANG->getLL("status"),$content,0,1);
			break;
			
                        case 2:
			        $content = $this->viewStatistics();
			        $this->content.=$this->doc->section($LANG->getLL("stats"),$content,0,1);
			break;
			
			case 3:
				$content = $this->makeExamples();
				$this->content.=$this->doc->section($LANG->getLL("examples"),$content,0,1);
			break;
		} 
	}
	
	/* View current mail delevery, if any */
	function viewStatus() {
	    global $TYPO3_DB;	
	    global $LANG;


	    /* Changes status? */
	    if ($_REQUEST['send_now']) {
		$TYPO3_DB->sql_query("UPDATE pages SET tx_tcdirectmail_senttime = ".time()." WHERE uid = $_REQUEST[id]");
	    }
	    if ($_REQUEST['send_test']) {
		$TYPO3_DB->sql_query("UPDATE pages SET tx_tcdirectmail_dotestsend = 1 WHERE uid = $_REQUEST[id]");
	    }


	    

	    /* Get page info */
	    $rs = $TYPO3_DB->exec_SELECTquery('tx_tcdirectmail_real_target, tx_tcdirectmail_test_target, tx_tcdirectmail_senttime, tx_tcdirectmail_dotestsend', 'pages', "uid = $_REQUEST[id]");
	    list ($targetUid, $testUid, $sendtime, $do_testsend) = $TYPO3_DB->sql_fetch_row($rs);



	    /* Get starttime for lock-records */
	    $rs = $TYPO3_DB->exec_SELECTquery('begintime', 
					    'tx_tcdirectmail_lock', 
					    "stoptime = 0 AND pid = $_REQUEST[id]");
	    list ($begintime) = $TYPO3_DB->sql_fetch_row($rs);



	    $output .= '<form>';
	    
	    
	    /* Real sends? */
	    $output .= '<h3>Status real receivers</h3>';
	    if ($targetUid) {
		$rs = $TYPO3_DB->sql_query(tx_tcdirectmail_query::getSubstRealSQL($targetUid));
		$total_to_send = $TYPO3_DB->sql_num_rows($rs);
	    
		if ($begintime) {		
		    $rs = $TYPO3_DB->exec_SELECTquery('COUNT(uid)',
						'tx_tcdirectmail_sentlog',
						"begintime = '$begintime' AND pid = $_REQUEST[id]");
						
						
		
    		    list ($already_sent) = $TYPO3_DB->sql_fetch_row($rs);

		    $output .= "<p>Currently sending: <strong>$already_send / $total_to_send</strong></p>";
		} elseif ($sendtime != 0) {
		    $output .= "<p>Sceduled send at <strong>".strftime('%Y-%m-%d %H:%M', $sendtime)."</strong> to receivers <strong>#$total_to_send</strong></p>";
		} else {
		    $output .= '<p>Not currently sceduled or sending</p>';
		    $output .= '<p><input type="submit" name="send_now" value="'.$LANG->getLL('send_now').'" /></p>';
		}
	    } else {
		$output .= '<p><strong>No real receivers defined.</strong></p>';
	    }
		
	    /* Test sends? */
	    $output .= '<h3>Status test receivers</h3>';
	    if ($testUid) {
		if ($do_testsend) {
		    $output .= '<p>Sceduled test send.</p>';
		} else {
		    $output .= '<p>Not currently sending</p>';
		    $output .= '<p><input type="submit" name="send_test" value="'.$LANG->getLL('send_test').'" /></p>';	
		}
	    } else {	
		$output .= '<p><strong>No test receivers defined.</strong></p>';
	    }
	    
	    $output .= '</form>';
	    
	    return $output;
	}
	
	/* View number of mails delivered in the past */
	function viewStatistics() {
	    global $TYPO3_DB;
	    global $LANG;

	    /* Get numbers for each session */
	    $sql = "SELECT lck.begintime, COUNT(lg.receiver)
					    FROM tx_tcdirectmail_lock lck
					    LEFT JOIN tx_tcdirectmail_sentlog lg ON lck.begintime = lg.begintime
					    WHERE lck.pid = $_REQUEST[id]
					    AND lg.pid = $_REQUEST[id]
					    GROUP BY 1";
					    
	    $rs = $TYPO3_DB->sql_query($sql);
					    
	    while (list($begintime, $num_receivers) = $TYPO3_DB->sql_fetch_row($rs)) {
		$total_receivers["$begintime"] = $num_receivers;
	    }
	    
	    /* Get numbers CONFIRMED for each session */
	    $sql = "SELECT lck.begintime, COUNT(lg.receiver)
					    FROM tx_tcdirectmail_lock lck
					    LEFT JOIN tx_tcdirectmail_sentlog lg ON lck.begintime = lg.begintime
					    WHERE lck.pid = $_REQUEST[id]
					    AND lg.pid = $_REQUEST[id]
					    AND beenthere = 1
					    GROUP BY 1";
					    
            $rs = $TYPO3_DB->sql_query($sql);
	    
	    while (list($begintime, $num_receivers) = $TYPO3_DB->sql_fetch_row($rs)) {
	        $total_confirmed["$begintime"] = $num_receivers;
	    }
						    					    

	    /* Select the actual receivers */
	    $sql = "SELECT lck.begintime, lck.stoptime, lg.sendtime, lg.receiver, beenthere
					    FROM tx_tcdirectmail_lock lck
					    LEFT JOIN tx_tcdirectmail_sentlog lg ON lck.begintime = lg.begintime
					    WHERE lck.pid = $_REQUEST[id]
					    AND lg.pid = $_REQUEST[id]
					    ORDER BY 1, 2, 3, 4";

	    $rs = $TYPO3_DB->sql_query($sql);
	    	    
	    /* Display */
	    $output .= '<table>';
	    $output .= '<tr><td>'.
			    $LANG->getLL('date').'</td><td>'.
			    $LANG->getLL('fromtime').'</td><td>'.
			    $LANG->getLL('totime').'</td><td>'.
			    $LANG->getLL('total_receivers').'</td><td>'.
			    $LANG->getLL('total_confirmed').'</td></tr>';
			    
	    while (list($begintime, $stoptime, $sendtime, $receiver, $beenthere) = $TYPO3_DB->sql_fetch_row($rs)) {
		if ($begintime != $old_begintime) {
		    $old_begintime = $begintime;
		
		    if ($_REQUEST['begintime'] == $begintime) {
			$output .= "<tr style=\"background-color: eeffee;\">
				    <td><strong>".strftime('%Y-%m-%d',$begintime)."</strong></td>
				    <td>".strftime('%H:%M',$begintime).'</td><td>'.strftime('%H:%M',$stoptime)."</td>
				    <td align=right>".$total_receivers["$begintime"]."</td><td align=right>".intval($total_confirmed["$begintime"])."</td></tr>";
		    } else {
			$output .= "<tr style=\"background-color: eeeeee;\">
				    <td><a href=\"index.php?id=$_REQUEST[id]&begintime=$begintime\"><strong>".
				    strftime('%Y-%m-%d',$begintime)."</strong></a></td>
				    <td>".strftime('%H:%M',$begintime).'</td><td>'.strftime('%H:%M',$stoptime)."</td>
				    <td align=right>".$total_receivers["$begintime"]."</td><td align=right>".intval($total_confirmed["$begintime"])."</td></tr>";
		    }
		}
		
		if ($_REQUEST['begintime'] == $begintime) {
		    if ($beenthere) {
			$output .= '<tr><td><img src="../confirmed.gif" alt="confirmed"/></td><td colspan="2">'.strftime('%H:%M:%S',$stoptime)."</td><td colspan=\"2\">$receiver</td></tr>";
		    } else {
			$output .= '<tr><td><img src="../unconfirmed.gif" alt="confirmed"/></td><td colspan="2">'.strftime('%H:%M:%S',$stoptime)."</td><td colspan=\"2\">$receiver</td></tr>";
		    }
		}
	    }
	    $output .= '</table>';
	    
	    return $output;
	}
	
	function makeExamples() {
	    global $LANG;
	    global $TYPO3_DB;
	    include ('target_examples.php');
	    
	    if ($_REQUEST['example_made']) {
		foreach ($_REQUEST['example'] as $key => $dummy) {
		    $output .= '<p><strong>'.$LANG->getLL('example_made').'</strong></p>';
		    $output .= '<p>';
		    $output .= $LANG->getLL('prependExampleText').' "'.$examples[$key]['title'].'" '.$LANG->getLL('appendExampleText');
	    	    $output .= '</p>';
		    
		    $ins = $examples[$key];
		    $ins['pid'] = $_REQUEST['id'];
		    $ins['cruser_id'] = $GLOBALS['BE_USER']->user['uid'];
		    $ins['crdate'] = time();
		    $ins['tstamp'] = time();

		    $TYPO3_DB->exec_INSERTquery('tx_tcdirectmail_targets', $ins);
		}
	    } else {
		$output .= '<form action="index.php"><table>';
		$output .= '<input type="hidden" name="example_made" value="1" />';
		$output .= '<input type="hidden" name="id" value="'.$_REQUEST['id'].'" />';
		$output .= '<tr><td>&nbsp;</td><td><strong>'.$LANG->getLL('description').'</strong></td></tr>';
		
		foreach ($examples as $name => $example) {
		    $output .= '<tr><td>';
		    $output .= '<input type="submit" name="example['.$name.']" value="'.$LANG->getLL('install').'" />';
		    $output .= '</td><td>';
		    $output .= '<p><strong>'.$example['title'].'</strong></p>';
		    $output .= '<p>'.$example['description'].'</p>';
		    $output .= '</td></tr>';
		}
		$output .= '</table></form>';
	    }
	    
	    return $output;
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tcdirectmail/mod1/index.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tcdirectmail/mod1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_tcdirectmail_module1");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>